import numpy as np
import sys
sys.argv = ['pdm']

from keras.layers import Layer, Input, Dropout, Conv3D, Activation, add, BatchNormalization, UpSampling3D,Conv3DTranspose, Flatten, concatenate, MaxPooling3D
from keras_contrib.layers.normalization.instancenormalization import InstanceNormalization, InputSpec
from keras.models import model_from_json
import tensorflow as tf
tf.compat.v1.disable_eager_execution()

# except:
#     #slicer.util.pip_install('keras-gpu')
#     slicer.util.pip_install('tensorflow-gpu')
#     slicer.util.pip_install('tensorflow')
#     slicer.util.pip_install('keras')
#
#     from keras.layers import Layer, Input, Dropout, Conv3D, Activation, add, BatchNormalization, UpSampling3D, Conv3DTranspose, Flatten, concatenate, MaxPooling3D
#     from keras_contrib.layers.normalization.instancenormalization import InstanceNormalization, InputSpec
#     from keras.models import model_from_json
#     import tensorflow as tf


class ReflectionPadding3D(Layer):
    def __init__(self, padding=(1, 1, 1), **kwargs):
        self.padding = tuple(padding)
        self.input_spec = [InputSpec(ndim=5)]
        super(ReflectionPadding3D, self).__init__(**kwargs)

    def compute_output_shape(self, s):
        size_increase = [0, 2 * self.padding[0], 2 * self.padding[1], 2 * self.padding[2], 0]
        output_shape = list(s)

        for i in range(len(s)):
            if output_shape[i] == None:
                continue
            output_shape[i] += size_increase[i]

        return tuple(output_shape)

    def call(self, x, mask=None):
        w_pad, h_pad, d_pad = self.padding
        return tf.pad(x, [[0, 0], [h_pad, h_pad], [w_pad, w_pad], [d_pad, d_pad], [0, 0]], 'REFLECT')

    def get_config(self):
        config = {'padding': self.padding}
        base_config = super(ReflectionPadding3D, self).get_config()
        return dict(list(base_config.items()) + list(config.items()))


model_path = "E:\\crop_GAN\\Model\\runs\\20210910-153137-data_for_model_LR_1e-05_RL_9_DF_64_GF_32_RF_70\\models\\"
model_num = 322
json_file =  open(model_path+"G_A2B_model_epoch_"+str(model_num)+".json",'r')
loded_model_json = json_file.read()
json_file.close()

G_A2B = model_from_json(loded_model_json, custom_objects={'ReflectionPadding3D':ReflectionPadding3D, 'InstanceNormalization':InstanceNormalization} )
G_A2B.load_weights(model_path+'G_A2B_model_epoch_'+str(model_num)+'.hdf5')


def AI_simulation(AI_input):

    result = G_A2B.predict(AI_input[np.newaxis, :, :, :, np.newaxis])
    result = np.squeeze(result)

    return result